#!/usr/bin/ruby

# EliseWebServer
# Fichier : DirList.rb
# version : 1
# Date cration : 22.08.04
# Date modification : 22.08.04
#
# Gnre une page html en listant les fichiers/rpertoires d'un dossier

class DirList
   
   #la liste des fichiers/rep en html
   @list
   
   def initialize(dir)
      @list = ''
      files = Array::new
      Dir::entries(dir).sort.each{|file|
         if !File::directory?(dir + '/' + file)
            files << file
         else
            @list += '<a href="' + file + '/">'+ file + '</a><br />'
         end
      }
      @list += '<hr />'
      files.each{|file|
         @list += '<a href="' + file + '">'+ file + '</a><br />'
      }
   end
   
   def print
      @list
   end
end
