#!/usr/bin/ruby

# RubyWebServer
# Fichier : WebServer.rb
# version : 1
# Date cration : 16.09.03
# Date modification : 16.09.03
#
# Description :
# Attends qu'une nouvelle connexion soit effectue.

require 'socket'
require 'thread'

require 'WebConnection.rb'
require 'user_settings.rb'

class WebServer
   def start
   
      #charge les applications
      unfindedApplications = Array::new
      APPLICATIONS.each{|path, className|
         realPath = ROOT_DIR + path
         if File::exist?(realPath)
            begin
               require realPath
            rescue Exception => e
               puts "Error in #{path} :"
               puts e.message
            end
         else #si l'application n'est pas trouve alors elle est enlev de la liste
            APPLICATIONS.delete(path)
         end
      }
   
      #coute sur un port
      server = TCPserver::open(LISTEN_PORT)
      
      #cre une "WebConnection" pour chaque nouvelle connexion
      while true         
         WebConnection::new(server.accept)
       end
   end
end
