# Represente le login
# date : 5.05.05
# auteur : G.Burri
# date : 5.05.05
# auteur : G.Burri

require 'md5'

require 'ek_objet.rb'
require 'ek_inscrit.rb'

class EkLogin < EkObjet

   def initialize(session)
      @session = session
          
      #si l'utilisateur possde une session avec un id d'inscrit alors on l'utilise
      @inscrit = EkInscrit::new(session.get('id_inscrit'))
   end
   
   def EkLogin::input(input, session)
      #un user se log
      if input.get('action') == 'log'
         pass = MD5::new(input.get('pass')).hexdigest
         login = input.get('login')
         
         num = Euphorik::dbCon.query("SELECT id FROM inscrit WHERE pseudo = '#{login}' AND pass = '#{pass}'")
         if Euphorik::dbCon.nbRow(num) == 1
            session.set('id_inscrit', Euphorik::dbCon.firstRow(num)[0].to_i)
         else
            session.set('error_login', 'cannot_log')
         end
         Euphorik::dbCon.freeQuery(num)
         
      #l'utilisateur souhaite se dlogger
      elsif input.get('action') == 'logout'
         session.set('id_inscrit', nil)
      end      
   end
   
   def inscrit
      @inscrit
   end

   #Retourne l'element sous la forme d'html
   def print
      #si logg alors propose de se dlogger
      if @inscrit.logged?
         form = Formulaire::new('logout')
         form.addItem(Submit::new('logout'))         
         @inscrit.printAbstract + form.getHtml
         
      #si pas logg alors propose de se logger ou de se rendre sur la page d'inscription
      else
      
         form = Formulaire::new('log')
         form.addItem(LineEdit::new('', 'login', 10, 30))
         form.addItem(LineEdit::new('', 'pass', 10, 10, '', true))
         form.addItem(Submit::new('login'))
         
         case @session.get('error_login')
         when 'cannot_log' then @session.set('error_login', nil); EkErreur::print('mauvais login ou pass') else '' end +
         form.getHtml + '<a href="main.rb?p=inscription">s\'inscrire</a>'
      end
   end
end


