require 'corps.rb'

class Liens < Corps
   def initialize(login)
      @login = login
   end

   def getHTML
      Liens::charger
      @@html.gsub(/\{admin[^\{]+\}/){|edit|
         if @login.logged?
            /\{admin:([^:]+):([^:]+)\}/ =~ edit
            " <a class=\"lienEdit\" href=\"index.rb?action=edit_liens&type=#{$1}&nom=#{$2}\">[edit]</a>"
         end
      }
   end

   #{<cat => ({ <subcat => [[<name>, <link>]*] }|[[<name>, <link>]*])*}
   @@liens = Hash::new
   @@html = String::new
   @@date_fichier = Time::new #la date du fichier au moment de la dernire lecture
   @@fichier_liens = 'bookmarks.xml'

   def Liens::mettreAJourHTML
      @@html = String::new
      liens_tab = @@liens.sort
      nb_liens_affiche = 0
      @@html += '<div class="liens_partie" >'
      liens_tab.each{|categorie_subcat|
         nb_liens_affiche += 1
         @@html += "<h3>#{categorie_subcat[0].capitalize}{admin:cat:#{categorie_subcat[0]}}</h3>"
         categorie_subcat[1].sort.each{|subcat_liens|
            @@html += "<h4>#{subcat_liens[0]}{admin:subcat:#{subcat_liens[0]}}</h4>"
            @@html += "<ul>"
            subcat_liens[1].sort.each{|lien|
               @@html += "<li><a href=\"#{lien[1]}\" >#{lien[0]}{admin:lien:#{lien[0]}}</a></li>"
            }
         @@html += "</ul>"
         }

         if nb_liens_affiche != liens_tab.size and nb_liens_affiche%1 == 0
            @@html += '</div><div class="liens_partie" >'
         end
      }
      @@html += '</div>'
   end

   def Liens::charger
      #si le fichier  chang sur le disque alors on le recharge
      if @@date_fichier != t = File::mtime(@@fichier_liens)
         @@date_fichier = t
         file = File::new(@@fichier_liens)
         doc = REXML::Document::new(file)

         doc.each_element('bookmarks/cat'){|categorie|
            @@liens[categorie.attributes['name']] = Hash::new
            categorie.each_element('subcat'){|subcat|
                @@liens[categorie.attributes['name']][subcat.attributes['name']] = Array::new
               subcat.each_element('link'){|lien|
                 @@liens[categorie.attributes['name']][subcat.attributes['name']].push([lien.attributes['name'], lien.get_elements('url')[0].text])
               }
            }
         }

         Liens::mettreAJourHTML
      end
   end

   Liens::charger
end
