#!/usr/bin/ruby

# RubyWebServer
# Fichier : Session.rb
# version : 1
# Date cration : 2.02.05
#
# Description :
# Gestion des sessions

require "constants.rb"

class Session

   def initialize(cookie)
   
      #extraction de l'id de session
      if cookie != ''
         cookie =~ /#{COOKIE_SESSION_NAME}=([^;]*)/
      end
      
      @clientID = $1
      #puts 'client ID :'
      #p $1
      #puts 
   
      #puts 'path :'
      #p path
      #puts
   end
   
   def get(var)
      if @clientID != nil
         return @@data[@clientID][var]
      end
      return ''
   end   
   
   def set(var, value)
      if @clientID == nil
         @clientID = rand(1_000_000_000_000_000_000).to_s
         @createCookie = true
      end
      @@data[@clientID] = { var => value }
   end
   
   def getID
      @clientID
   end
   
   def createCookie?
      @createCookie
   end
   
private 
   #{ <client id> => { <var> => <data (text)> } }
   @@data = Hash::new
   
   @clientID #est gal  nil si pas de session en cours
   
   @createCookie = false
end
