# Differente mthode de classe pour le formatage du texte de sortie
# date : 5.05.05
# auteur : G.Burri

require 'cgi'

class Format
@@mois = {'01' => 'janvier', '02' => 'fvrier', '03' => 'mars', '04' => 'avril', '05' => 'mai', '06' => 'juin',
'07' => 'juillet', '08' => 'aout', '09' => 'septembre', '10' => 'octobre', '11' => 'novembre', '12' => 'decembre'
}
   
@@smiles = {
   ':)' => 'smile.gif'
}

   def Format::date(date)
      /^(\d{4})-(\d{2})-(\d{2}) (\d{2}):(\d{2})/ =~ date
            
      if Time::now.year == $1.to_i 
         "#{$3.to_i} #{@@mois[$2]} @ #{$4}h#{$5}"   
      else
         "#{$3.to_i} #{@@mois[$2]}.#{$1} @ #{$4}h#{$5}"
      end
   end
   
   # Formate une chaine.
   # p1 : si vrai alors utilise la syntaxe wiki
   # p2 : si vrai alors remplace les smiles par des images
   def Format::format(wiki = true, smile = true)
   
   end

   # Format une chaine pour pouvoir la mettre dans une requete SQL (echappe les ')
   def Format::escapeBD(text)
      return text.gsub("'", "\\\\\'")
   end
   
   def Format::escape(text)
      CGI::escape(text)
   end
   
   def Format::unescape(text)
      CGI::unescape(text)
   end
   
   def Format::escapeHTML(text)
      CGI::escapeHTML
   end
   
   def Format::unescapeHTML(text)
      CGI::unescapeHTML(text)
   end
end
