# Differente mthode de classe pour le formatage du texte de sortie
# date : 5.05.05
# auteur : G.Burri

require 'cgi'

class Format
@@mois = {1 => 'janvier', 2 => 'fvrier', 3 => 'mars', 4 => 'avril', 5 => 'mai', 6 => 'juin',
7 => 'juillet', 8 => 'aout', 9 => 'septembre', 10 => 'octobre', 11 => 'novembre', 12 => 'decembre'
}
   
@@smiles = {
   ':)' => 'smile.gif'
}
   
   # p1 : DBI::Timestamp : la date
   def Format::dateDBI(date)
      #/^(\d{4})-(\d{2})-(\d{2}) (\d{2}):(\d{2})/ =~ date

      if Time::now.year == date.year
         "#{date.day} #{@@mois[date.month]} @ #{date.hour}h#{Format::integerFix(date.minute, 2)}"   
      else
         "#{date.day} #{@@mois[date.month]} #{date.year} @ #{date.hour}h#{Format::integerFix(date.minute, 2)}" 
      end
   end
   
   #prends un entier et un retourne une chaine avec un certain nombre de 0 devant
   def Format::integerFix(i, taille)
      s = i.to_s
      "0" * (taille - s.size) + s
   end

   # Formate une chaine.
   # p1 : si vrai alors utilise la syntaxe wiki
   # p2 : si vrai alors remplace les smiles par des images
   def Format::format(wiki = true, smile = true)
   
   end

   # Format une chaine pour pouvoir la mettre dans une requete SQL (echappe les ')
   def Format::escapeBD(text)
      return text.gsub("'", "\\\\\'")
   end
   
   def Format::escape(text)
      CGI::escape(text)
   end
   
   def Format::unescape(text)
      CGI::unescape(text)
   end
   
   def Format::escapeHTML(text)
      CGI::escapeHTML
   end
   
   def Format::unescapeHTML(text)
      CGI::unescapeHTML(text)
   end
end
